#ifndef __BASESTATIONWINDOW_H__
#define __BASESTATIONWINDOW_H__

#include <fltk/Widget.h>
#include <fltk/Window.h>
#include <fltk/SharedImage.h>

class BaseStationGUI;

class ImgView : public fltk::Widget
{
    int w,h;
    unsigned char* image;
    fltk::SharedImage* img;
    char imageName[32];
public:
    ImgView(int x,int y,int w,int h,const char* l);
    ~ImgView();

    virtual void draw();

    //void loadImage(int w,int h,unsigned char* imageD);
    void loadImage(char* s);
};

class BaseStationWindow : public fltk::Window
{
public:
    BaseStationGUI* gui;
    BaseStationWindow(int x,int y,int w,int h,const char* l);
    BaseStationWindow(int x,int y,const char* l);

    virtual int handle(int ev);
};

#endif
