#ifndef _IMGSRV_
#define _IMGSRV_

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 
#include <string.h>
#include <unistd.h>
#include <iostream>
#include <fstream>
#include "gd.h"

#include "Packet.h"
#include "Thread.h"

#define ADDR "169.236.152.213"
#define PORT "5003"

using namespace std;

class ImgSrv : public Thread
{
    private:
        int sockfd;
        gdImagePtr img;
        Packet* p;
    public:
        ImgSrv(char* addr = ADDR, char* sPort = PORT);  // Connect to image server
        ~ImgSrv(); // Teardown conenction
        gdImagePtr getImage(char *msg = NULL);
        void error(char *msg);

        SignalMutex imgMutex;
        Packet* front();
        void pop_front();

        virtual void Setup();
        virtual void Execute();
        virtual void Exit();
};

#endif
