#ifndef __PACKET_H__
#define __PACKET_H__

#define MSG  1
#define IMG  2
#define CMD  3
#define DATA 4

class Packet
{
public:
    int type;
    int size;
    char* data;
   
    Packet();
    Packet(char* pData);
    Packet(int pType,int pSize);
    Packet(int pType,int pSize,char* pData);
    Packet(Packet* p);
    ~Packet();
    void destroy();
    void create(int pType,int pSize,char* pData);

    void packHeader(char* buf);
    int packData(char* buf,int pos,int blockSize);

    void operator=(const Packet& p);
};

#endif
