#include "Thread.h"

using namespace std;

void Thread::Wait(Thread* t)
{
    pthread_join(t->m_thread,NULL);
}

Thread::Thread()
{
    bPaused = false;
    bKill = false;
}

void Thread::Start()
{
    pthread_create(&m_thread,NULL,Thread::EntryPoint,this);
}

void Thread::Stop()
{
    void* tmp;
    bKill = true;
    Exit();
    pthread_cancel(m_thread);
    if (pthread_join(m_thread,&tmp))
        printf("Error\n");
        //cout << "Thread::Stop() - Error" << endl;
}

void Thread::Resume()
{
    //if(pauseMutex.trylock())
    //{
    if (bPaused)
    {
        cout << "thread resumed" << endl;
        pauseMutex.signal();
        bPaused = false;
    }
        //pauseMutex.unlock();
    //}
}

void Thread::Wait()
{
    cout << "thread paused" << endl;
    bPaused = true;
    pauseMutex.wait();
}

void Thread::Run()
{
    Setup();
    Execute();
    Exit();
}

void* Thread::EntryPoint(void* pthis)
{
    Thread * pt = (Thread*)pthis;
    pt->Run();
}

void Thread::Setup()
{
    // Do any setup here
}

void Thread::Execute()
{
    // Your code goes here
}

void Thread::Exit()
{
}
