#include <iostream>
#include <signal.h>
#include <pthread.h>
#include <playerclient.h>

#include "Talon.h"
#include "ThisRobot.h"

using namespace std;

#define NO_USAR

Talon* talon;

void GetOdometry(TOdo& odometry) {}
void GetSensation(TSense& sense) {}

void sigcb(int i)
{
    cout << "SIGNAL!" << endl;
    switch (i)
    {
        case SIGINT:
        case SIGQUIT:
        case SIGSEGV:
        case SIGABRT:
        case SIGILL:
        case SIGBUS:
        case SIGFPE:
        case SIGTERM:
        default:
            talon->Stop();
        break;
    }

    signal(i,SIG_DFL);
    raise(i);
}
int main(int argc,char** argv)
{
    signal(SIGINT,sigcb);
    signal(SIGQUIT,sigcb);
    signal(SIGSEGV,sigcb);
    signal(SIGABRT,sigcb);
    signal(SIGILL,sigcb);
    signal(SIGBUS,sigcb);
    signal(SIGFPE,sigcb);
    signal(SIGTERM,sigcb);

    talon = new Talon;

    talon->Start();

    Thread::Wait(talon);

    return 0;
}
/*
void* listenForCmds(void* arg)
{
    Connection* c = (Connection *)arg;
    if (!c->listen())
    {
        cout << "not listening" << endl;
        return NULL;
    }

    cout << "before getting packets..." << endl;
    Packet* p;
    while (1)
    {
        cout << "getting packets..." << endl;
        p = c->recv();
        if (p==NULL)
            break;
        switch (p->type)
        {
            case MSG:
                cout << "got a message" << p->data << endl;
            break;
            case IMG:
                cout << "why did I get an image..." << endl; 
            break;
            case CMD:
                cout << "got command: " << p->data << endl;
            break;
        }
    }

    //c->close();
    return NULL;
}

void* sendImgs(void* arg)
{
    Connection* c = (Connection *)arg;
    int s;
    char* buf;
    char tmp[32];
    FILE* f;
    gdImagePtr img;

#ifdef NO_USAR
    c->fdc = tcp_connect("localhost","5555");
    c->con = c->fdc;
#else
    if (!c->connect("base","7778"))
    {
        cout << "not connected!" << endl;
        return NULL;
    }
    cout << "Talon->Base: " << c->getSS("base") << endl;
        
        //Matt's addition
    f = fopen("img.jpg","wb");
    ImgSrv* is = new ImgSrv(UT_IP_ADDR,UT_IMG_PORT);
    img = is->getImage("OK");
    gdImageJpeg(img,f,50);
    gdImageDestroy(img);
    fclose(f);
    usleep(2000);
#endif


    f = fopen("img.jpg","rb");
    img = gdImageCreateFromJpeg(f);
    buf = (char *)gdImageJpegPtr(img,&s,50);
    gdImageDestroy(img);

    Packet p(IMG,s,buf);

    gdFree(buf);
#ifdef NO_USAR
    fclose(f);
    for (int i=0;i<10;i++)
    {
        cout << "Packet #" << i << endl;
        sprintf(tmp,"img%i.jpg",i);
        f = fopen(tmp,"rb");
        img = gdImageCreateFromJpeg(f);
        buf = (char *)gdImageJpegPtr(img,&s,50);
        sleep(1);
        Packet z(IMG,s,buf);
        if (!c->send(z,false))
        {
            cout << "DOH!" << endl;
            break;
        }
        fclose(f);
        gdImageDestroy(img);
        gdFree(buf);
    }

#else
    for (int i=0;i<10;i++)
    {
        img = is->getImage("OK");
        buf = (char *)gdImageJpegPtr(img,&s,50);
        Packet z(IMG,s,buf);
        cout << "Packet #" << i << endl;
        if (!c->send(z))
        {
            cout << "DOH!" << endl;
            break;
        }
        gdImageDestroy(img);
        gdFree(buf);
        //usleep(500000);
        sleep(1);
    }
    fclose(f);
#endif
    
}

int main(int argc,char** argv)
{
    pthread_t sendThread;
    pthread_t listenThread;

#ifdef NO_USAR
    Connection* listenC = new Connection;
    Connection* sendC   = new Connection;
#else
    Connection* listenC = new Connection(UT_IP_ADDR,UT_WCS_PORT,"talon1","7780","169.236.152.233");
    Connection* sendC   = new Connection(UT_IP_ADDR,UT_WCS_PORT,"talon1","7781","169.236.152.233");
#endif

    pthread_create(&sendThread,NULL,sendImgs,(void *)sendC);
    //pthread_create(&listenThread,NULL,listenForCmds,(void *)listenC);

    pthread_join(sendThread,NULL);
    //pthread_join(listenThread,NULL);

#ifdef NO_USAR
    tcp_close(listenC->fdl);
    tcp_close(listenC->con);
    tcp_close(sendC->fdl);
    tcp_close(sendC->con);
#else
    listenC->close();
    sendC->close(true);
#endif

    return 0;
}*/
