#ifndef __CONNECTIONMANAGER_H__
#define __CONNECTIONMANAGER_H__

#include <deque>
#include "ImgSrv.h"
#include "Connection.h"
#include "Packet.h"
#include "Thread.h"

//#define UT_IP_ADDR "169.236.152.213"
#define UT_IP_ADDR "143.215.131.215"
#define LOCAL_IP_ADDR "143.215.131.214"
//#define LOCAL_IP_ADDR "localhost"
#define UT_WCS_PORT "5874"
#define UT_IMG_PORT "5003"

#define PLAYER_IP_ADDR "localhost"
#define PLAYER_PORT "6665"

#define BASESTATION_NAME "BaseStation"
#define TALON_NAME "Talon"

//#define CONNECT_TO_USARSIM true
//#define CONNECT_TO_USARSIM false

class ConnectionManager : public Thread
{
    Connection* conSend;
    Connection* conRecv;
    
    char hName[64];
    char hIP[32];
    char hPort[16];
    char connectedTo[64];
    bool bUT;
public:

    ConnectionManager(char* name,char* ip,char* port,bool bConnectToUT=false);

    bool SendHandShake(char* name,char* port);
    bool WaitForHandShake();
    void Close();
    float getSS();

    void Send(Packet* p);
    Packet* Receive();

    virtual void Setup();
    virtual void Execute();
    virtual void Exit();
};

#endif

