#ifndef __JOYSTICKMANAGER_H__
#define __JOYSTICKMANAGER_H__

#include <SDL/SDL.h>
#include <SDL/SDL_joystick.h>
#include "Packet.h"
#include "Thread.h"

class JoystickManager : public Thread
{
    int joystickIndex;
    SDL_Joystick* joy;
    Packet* p;
    bool bReady;

public:
    JoystickManager(int jIndex=-1);

    bool Ready();
    bool AnyButton();

    Packet* getPacket();

    virtual void Setup();
    virtual void Execute();
    virtual void Exit();
};

#endif
