#ifndef __SLAM_H__
#define __SLAM_H__

#include <fstream>
#include <deque>
#include "ConnectionManager.h"
#include "Thread.h"

#include "high.h"
#include "mt-rand.h"

class TSense_t
{
public:
    TSense s;
};

class Slam : public Thread
{
    int currLine;
    ofstream log;

    int continueSlam;
    SignalMutex dataMutex;
    TOdo currOdo;
    TSense_t currSense;

public:
    Slam(bool bGT=false);

    void push(char* sData);
    void GetOdometry(TOdo& o);
    void GetSensation(TSense& s);
    void CurrOdometry(TOdo& o);
    void CurrSensation(TSense& s);

    virtual void Setup();
    virtual void Execute();
    virtual void Exit();
};

#endif
