#ifndef __TALON_H__
#define __TALON_H__

#include "Thread.h"
#include "ConnectionManager.h"
#include "ProxyManager.h"


class Talon : public Thread
{
    bool bOK;
    bool bIS;
    ConnectionManager*  connectionManager;
    ProxyManager*       proxyManager;
    ImgSrv*             is;

    SignalMutex imgMutex;

public:
    Talon();

    virtual void Setup();
    virtual void Execute();
    virtual void Exit();
};

#endif

